#include<stdio.h>

typedef struct _ul
{
    int idx;
    double value; 
    struct _ul *uus;  
} ul;


ul *arvutus(int a, double x)
{
          ul *tmp =malloc(sizeof(ul));
          tmp->idx=a;
          if (a<=1)
          {
             tmp->uus = NULL;
             tmp->value =1/x    ;     
          } else
          {
             tmp->uus = arvutus(a-1,x);
             tmp->value =(a/(x+a-1))*tmp->uus->value  ;      
          }
          return tmp;
}


void v2ljasta (ul *k)
{
     if(k)
     {
            printf("%3d : %g\n", k->idx, k->value);
            v2ljasta(k->uus);
            }     
}

void vabastam2lu(ul *k)
{
     if (k)
     {
        vabastam2lu(k->uus);
        free(k);          
     }     
}

int main (void)
{
    int M;
    double X;
    printf("anna naturaalarv M vahemikus 1 kuni 10\n");
    scanf("%d",&M);
    printf("M:%d\n",M);
    printf("anna reaalarv X \n");
    scanf("%lf",&X);
    printf("X:%lf\n",X);
    ul *algus = arvutus(M,X); 
    v2ljasta(algus);
    vabastam2lu(algus);
    getchar(); 
    getchar(); 
    return(0);
    }
